<?php

error_reporting(E_ALL);
require_once 'IXR_Library.php.inc';
// Load in the Joomla framework
define('_JEXEC', 1);
define('JPATH_BASE', $_SERVER['DOCUMENT_ROOT']);
define('DS', DIRECTORY_SEPARATOR);
require_once ( JPATH_BASE . DS . 'includes' . DS . 'defines.php' );
require_once ( JPATH_BASE . DS . 'includes' . DS . 'framework.php' );
require_once ( JPATH_BASE . DS . 'libraries' . DS . 'joomla' . DS . 'factory.php' );


/* Functions defining the behaviour of the server */

function nitroGetCampaignStats($args) {
    $db = JFactory::getDBO();
    $query = $db->getQuery(true);
    $query->select('*');
    $query->from('#__dcl_campaign_stats');
    $db->setQuery((string) $query);
    $dclCampaignStats = $db->loadAssocList();
    return $dclCampaignStats;
}

function nitroSetCampaignResults($args) {
    $db = JFactory::getDBO();
    $tableName = '#__dcl_campaign_results';
    $query = "TRUNCATE TABLE $tableName";
    $db->setQuery((string) $query);
    $truncated = $db->query();

    $query = $db->getQuery(true);
    if ($truncated !== FALSE) {
        if (is_array($args) && count($args)) {
            $campaignResults = $args;
            if (count($campaignResults)) {
                $query->insert($tableName);
                $query->columns('campaign_id,pinger,results');
                foreach ($campaignResults as $cR) {
                    $campaignId = $cR['campaign_id'];
                    $pinger = $cR['pinger'];
                    $results = $cR['results'];
                    $valueString = "'$campaignId','$pinger','$results'";
                    $query->values($valueString);
                }
            }
            $db->setQuery($query);
            return $db->query();
        }
    }
    return false;
}

function nitroAddNewArticle($args) {
    if (isset($args)) {
        $table = JTable::getInstance('Content', 'JTable', array());

        $articleTitle = str_replace('.', '', $args['title']);
        $articleAlias = str_replace(' ', '-', strtolower($articleTitle)) . '-' . uniqid();
        $data = array(
            'catid' => 9,
            'title' => $articleTitle,
            'alias' => $articleAlias,
            'introtext' => $args['introtext'],
            'fulltext' => $args['fulltext'],
            'state' => 1,
            'created_by' => 429,
            'created_by_alias' => 'Joomla'
        );

        // Bind data
        if (!$table->bind($data)) {
            $this->setError($table->getError());
            return false;
        }

        // Check the data.
        if (!$table->check()) {
            $this->setError($table->getError());
            return false;
        }

        // Store the data.
        if (!$table->store()) {
            $this->setError($table->getError());
            return false;
        } else {
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('*');
            $query->from('#__content');
            $query->where("alias = '$articleAlias'");
            $db->setQuery((string) $query);
            $lastArticle = $db->loadObject();
            if (isset($lastArticle->id)) {
                $reArr['post_id'] = $lastArticle->id;
                $reArr['post_url'] = $lastArticle->id . '-' . $articleAlias;
                return $reArr;
            }
        }
    }
    return false;
}

function nitroGetTime() {
    return date('H:i:s');
}

/* Create the server and map the XML-RPC method names to the relevant functions */

$server = new IXR_Server(array(
    'nitro.getTime' => 'nitroGetTime',
    'nitro.getCampaignStats' => 'nitroGetCampaignStats',
    'nitro.setCampaignResults' => 'nitroSetCampaignResults',
    'nitro.addNewArticle' => 'nitroAddNewArticle'
        ));
